﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AirplaneWithRadar
{
    internal class AirplaneCompareByColor : IComparer<IDrawningObject>
    {
        public int Compare(IDrawningObject? x, IDrawningObject? y)
        {
            if (x == null && y == null)
            {
                return 0;
            }
            if (x == null && y != null)
            {
                return 1;
            }
            if (x != null && y == null)
            {
                return -1;
            }
            var xAirplane = x as DrawningObjectAirplane;
            var yAirplane = y as DrawningObjectAirplane;
            if (xAirplane == null && yAirplane == null)
            {
                return 0;
            }
            if (xAirplane == null && yAirplane != null)
            {
                return 1;
            }
            if (xAirplane != null && yAirplane == null)
            {
                return -1;
            }
            var xEntityAirplane = xAirplane._airplane.Airplane;
            var yEntityAirplane = yAirplane._airplane.Airplane;
            var baseColorCompare = xEntityAirplane.BodyColor.ToArgb().CompareTo(yEntityAirplane.BodyColor.ToArgb());
            if (baseColorCompare != 0)
            {
                return baseColorCompare;
            }
            if (xEntityAirplane is EntityAirplaneWithRadar xAirplaneWithRadar && yEntityAirplane is EntityAirplaneWithRadar yAirplaneWithRadar)
            {
                var dopColorCompare = xAirplaneWithRadar.DopColor.ToArgb().CompareTo(yAirplaneWithRadar.DopColor.ToArgb());
                if (dopColorCompare != 0)
                {
                    return dopColorCompare;
                }
            }
            var speedCompare = xAirplane._airplane.Airplane.Speed.CompareTo(yAirplane._airplane.Airplane.Speed);
            if (speedCompare != 0)
            {
                return speedCompare;
            }
            return xAirplane._airplane.Airplane.Weight.CompareTo(yAirplane._airplane.Airplane.Weight);
        }
    }
}
