﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AirplaneWithRadar
{
    internal class AirplaneCompareByType : IComparer<IDrawningObject>
    {
        public int Compare(IDrawningObject? x, IDrawningObject? y)
        {
            if (x == null && y == null)
            {
                return 0;
            }
            if (x == null && y != null)
            {
                return 1;
            }
            if (x != null && y == null)
            {
                return -1;
            }
            var xAirplane = x as DrawningObjectAirplane;
            var yAirplane = y as DrawningObjectAirplane;
            if (xAirplane == null && yAirplane == null)
            {
                return 0;
            }
            if (xAirplane == null && yAirplane != null)
            {
                return 1;
            }
            if (xAirplane != null && yAirplane == null)
            {
                return -1;
            }
            if (xAirplane.GetAirplane.GetType().Name != yAirplane.GetAirplane.GetType().Name)
            {
                if (xAirplane.GetAirplane.GetType().Name == "DrawningAirplane")
                {
                    return -1;
                }
                return 1;
            }
            var speedCompare = xAirplane.GetAirplane.Airplane.Speed.CompareTo(yAirplane.GetAirplane.Airplane.Speed);
            if (speedCompare != 0)
            {
                return speedCompare;
            }
            return xAirplane.GetAirplane.Airplane.Weight.CompareTo(yAirplane.GetAirplane.Airplane.Weight);
        }
    }
}
