namespace AirplaneWithRadar
{
    public partial class FormAirplane : Form
    {
        private DrawningAirplane _airplane;
        /// <summary>
        ///  
        /// </summary>
        public DrawningAirplane SelectedAirplane { get; private set; }
        public FormAirplane()
        {
            InitializeComponent();
        }
        private void Draw()
        {
            Bitmap bmp = new(pictureBoxAirplane.Width, pictureBoxAirplane.Height);
            Graphics gr = Graphics.FromImage(bmp);
            _airplane?.DrawTransport(gr);
            pictureBoxAirplane.Image = bmp;
        }
        /// <summary>
        ///   
        /// </summary>
        private void SetData()
        {
            Random rnd = new();
            _airplane.SetPosition(rnd.Next(10, 100), rnd.Next(10, 100), pictureBoxAirplane.Width, pictureBoxAirplane.Height);
            toolStripStatusLabelSpeed.Text = $": {_airplane.Airplane.Speed}";
            toolStripStatusLabelWeight.Text = $": {_airplane.Airplane.Weight}";
            toolStripStatusLabelBodyColor.Text = $": {_airplane.Airplane.BodyColor.Name}";
        }
        private void ButtonCreate_Click(object sender, EventArgs e)
        {
            Random random = new();
            Color myColor = new Color();
            ColorDialog MyDialog = new ColorDialog();
            if (MyDialog.ShowDialog() == DialogResult.OK)
            {
                myColor = MyDialog.Color;
            }
            _airplane = new DrawningAirplane(random.Next(30, 50), random.Next(1000, 2000), myColor);
            SetData();
            Draw();
        }
        private void ButtonMove_Click(object sender, EventArgs e)
        {
            //  
            string name = ((Button)sender)?.Name ?? string.Empty;
            switch (name)
            {
                case "buttonUp":
                    _airplane?.MoveTransport(Direction.Up);
                    break;
                case "buttonDown":
                    _airplane?.MoveTransport(Direction.Down);
                    break;
                case "buttonLeft":
                    _airplane?.MoveTransport(Direction.Left);
                    break;
                case "buttonRight":
                    _airplane?.MoveTransport(Direction.Right);
                    break;
            }
            Draw();
        }
        private void PictureBoxAirplane_Resize(object sender, EventArgs e)
        {
            _airplane?.ChangeBorders(pictureBoxAirplane.Width, pictureBoxAirplane.Height);
            Draw();
        }
        /// <summary>
        ///    ""
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void buttonCreateModify_Click(object sender, EventArgs e)
        {
            Random rnd = new();
            Color color = Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256), rnd.Next(0, 256));
            ColorDialog dialog = new();
            if (dialog.ShowDialog() == DialogResult.OK)
            {
                color = dialog.Color;
            }
            Color dopColor = Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256), rnd.Next(0, 256));
            ColorDialog dialogDop = new();
            if (dialogDop.ShowDialog() == DialogResult.OK)
            {
                dopColor = dialogDop.Color;
            }
            _airplane = new DrawningAirplaneWithRadar(rnd.Next(100, 300), rnd.Next(1000, 2000), color, dopColor,
                Convert.ToBoolean(rnd.Next(0, 2)), Convert.ToBoolean(rnd.Next(0, 2)), Convert.ToBoolean(rnd.Next(0, 2)));
            SetData();
            Draw();
        }

        private void buttonSelectCar_Click(object sender, EventArgs e)
        {
            SelectedAirplane = _airplane;
            DialogResult = DialogResult.OK;
        }
    }
}